#[macro_use(concat_string)]
extern crate concat_string;

pub fn concat_with_format(a: &str, b: &str) -> String {
    let c = format!("{} {}", a, b);
    c
}

pub fn concat_with_plus(a: &str, b: &str) -> String {
    let c = a.to_string() + " " + b;
    c
}

pub fn concat_with_concat_string_macro_crate(a: &str, b: &str) -> String {
    let c = concat_string!(a, " ", b);
    c
}

pub fn add(left: usize, right: usize) -> usize {
    left + right
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn it_works() {
        let result = add(2, 2);
        assert_eq!(result, 4);
    }
}
